#!/usr/bin/python
# -*- coding:Utf-8 -*-

import es
import keyvalues

adminOptions = ["auth", "group", "flags", "immunity"]
groupOptions = ["flags", "immunity"]

version = "v1.01"

def main ():
    es.ServerVar("messiah93_lib_getsmadmins").set(version)
    es.makepublic("messiah93_lib_getsmadmins")

def getAdmins (file):
    adminlist = {}
    
    if file == "admins.cfg":
        try:
            kFile = keyvalues.KeyValues(name = "getsmadminslib_get_admins")
            kFile.load(es.getString("eventscripts_gamedir") + "/addons/sourcemod/configs/" + file)
        except:
            return (False, "Cannot open file '%s'." % file)
        
        adminFileList = kFile.keys()
        for admin in adminFileList:
            adminlist[kFile[admin]["identity"]] = {}
            adminlist[kFile[admin]["identity"]]["name"] = admin
            for adminOption in adminOptions:
                try:
                    adminlist[kFile[admin]["identity"]][adminOption] = kFile[admin][adminOption]
                except:
                    adminlist[kFile[admin]["identity"]][adminOption] = None
    
    elif file == "admins_simple.ini":
        try:
            adminFile = None
            adminFile = open(es.getString("eventscripts_gamedir") + "/addons/sourcemod/configs/" + file, "r")
        except:
            return (False, "Cannot open file '%s'." % file)
        else:
            adminsFileLines = adminFile.readlines()
            for line in adminsFileLines:
                if not line.startswith("//"):
                    splitLine = line.split()
                    if not splitLine:
                        continue
                    
                    identity = splitLine[0]
                    if "!" in identity:
                        identity = identity.replace("!", "")
                    imm_flags_group = splitLine[1]
                    if not splitLine[2].startswith("//"):
                        password = splitLine[2]
                    else:
                        password = None
                    
                    adminlist[identity] = {}
                    if "@" in imm_flags_group:
                        adminlist[identity]["group"] = imm_flags_group
                        adminlist[identity]["immunity/flags"] = None
                    else:
                        adminlist[identity]["group"] = None
                        adminlist[identity]["immunity/flags"] = imm_flags_group
                    
                    if password:
                        adminlist[identity]["password"] = True
                    else:
                        adminlist[identity]["password"] = False
        finally:
            if adminFile:
                adminFile.close()
    
    else:
        return (False, "Arg 'file' must be 'admins.cfg' or 'admins_simple.ini'.")
    return (True, adminlist)

def getGroups ():
    grouplist = {}
    
    try:
        kFile = keyvalues.KeyValues(name = "getsmadminslib_get_groups")
        kFile.load(es.getString("eventscripts_gamedir") + "/addons/sourcemod/configs/admin_groups.cfg")
    except:
        return (False, "Cannot open file 'admin_groups.cfg'.")
    
    
    groupFileList = kFile.keys()
    for group in groupFileList:
        grouplist[group] = {}
        for groupOption in groupOptions:
            try:
                grouplist[group][groupOption] = kFile[group][groupOption]
            except:
                grouplist[group][groupOption] = None
    
    return (True, grouplist)

main()